(**************************************************************************)
(*  Lack - Package manager for non-root users                             *)
(*  (C) 2008 Olivier Schwander <olivier.schwander@ens-lyon.org>           *)
(*  http://chadok.info/lack                                               *)
(*                                                                        *)
(*  This file is part of Lack.                                            *)
(*                                                                        *)
(*  Lack is free software: you can redistribute it and/or modify          *)
(*  it under the terms of the GNU General Public License as published by  *)
(*  the Free Software Foundation, either version 3 of the License, or     *)
(*  (at your option) any later version.                                   *)
(*                                                                        *)
(*  Lack is distributed in the hope that it will be useful,             *)
(*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *)
(*  GNU General Public License for more details.                          *)
(*                                                                        *)
(*  You should have received a copy of the GNU General Public License     *)
(*  along with Lack.  If not, see <http://www.gnu.org/licenses/>.       *)
(*                                                                        *)
(**************************************************************************)

(* return the first node with the given tag *)
let rec find_node l tag =
  match l with
    | [] -> raise Not_found
    | x::q ->
        match x with
          | Xml.Element(s, _, _) when s = tag -> x
          | _ -> find_node q tag

(* return the content of the first pcdata of the first node with the
   given tag or empty string if it is missing *)
let rec find_value l tag =
  match l with
    | [] -> ""
    | x::q ->
        match x with
          | Xml.Element(s, _,
                        [Xml.PCData(value)]) when s = tag -> value
          | _ -> find_value q tag


